>From 48fe45e75eaa46358caac5d23b5373a359e023cc Mon Sep 17 00:00:00 2001
From: Ade Lee <alee@redhat.com>
Date: Fri, 8 Mar 2013 09:29:02 -0500
Subject: [PATCH] Plug resource leaks

---
 .../src/com/netscape/ca/CertificateAuthority.java  |   9 +-
 .../netscape/certsrv/authentication/AuthToken.java |  11 +-
 .../src/com/netscape/cms/logging/LogFile.java      |  21 ++-
 .../netscape/cms/profile/def/EnrollDefault.java    |   3 +-
 .../cms/profile/def/GenericExtDefault.java         |   3 +-
 .../netscape/cms/servlet/common/CMSTemplate.java   |   9 +-
 .../netscape/cms/servlet/csadmin/GetCookie.java    |   3 -
 .../com/netscape/cmscore/base/PropConfigStore.java |   6 +-
 .../com/netscape/cmscore/security/KeyCertUtil.java |  45 ++---
 .../com/netscape/cmscore/security/PWsdrCache.java  |  20 +--
 .../netscape/cmscore/util/ExceptionFormatter.java  |   7 +-
 .../certsrv/authentication/AuthTokenTest.java      |   9 +-
 .../java-tools/src/com/netscape/cmstools/BtoA.java |   4 +
 .../src/com/netscape/cmstools/DRMTool.java         |   4 +-
 .../src/com/netscape/cmstools/ExtJoiner.java       |   3 +-
 .../src/com/netscape/cmstools/GenExtKeyUsage.java  |  11 +-
 .../src/com/netscape/cmstools/PKCS10Client.java    |   2 +-
 .../src/com/netscape/cmstools/PasswordCache.java   |  20 +--
 base/kra/src/com/netscape/kra/EncryptionUnit.java  |   6 +-
 .../src/com/netscape/kra/NetkeyKeygenService.java  |  28 +--
 .../com/netscape/kra/TokenKeyRecoveryService.java  |  20 +--
 base/ocsp/src/com/netscape/ocsp/OCSPAuthority.java |   3 +-
 .../com/netscape/cmsutil/crypto/CryptoUtil.java    |  29 +--
 .../security/extensions/AccessDescription.java     |  15 +-
 .../extensions/AuthInfoAccessExtension.java        |  23 +--
 .../CertificateRenewalWindowExtension.java         |  17 +-
 .../extensions/CertificateScopeOfUseExtension.java |  23 +--
 .../extensions/InhibitAnyPolicyExtension.java      |  27 +--
 .../netscape/security/extensions/KerberosName.java |  53 +++---
 .../security/extensions/NSCertTypeExtension.java   |   9 +-
 .../extensions/PresenceServerExtension.java        |  29 +--
 .../extensions/SubjectInfoAccessExtension.java     |  23 +--
 .../netscape/security/pkcs/PKCS10Attribute.java    |  33 ++--
 .../netscape/security/pkcs/PKCS10Attributes.java   |  18 +-
 .../src/netscape/security/pkcs/PKCS9Attribute.java | 200 ++++++++++-----------
 .../netscape/security/pkcs/PKCS9Attributes.java    |  13 +-
 .../src/netscape/security/pkcs/SignerInfo.java     |  39 ++--
 base/util/src/netscape/security/provider/DSA.java  |   3 +-
 .../netscape/security/provider/DSAParameters.java  |  17 +-
 .../netscape/security/provider/RSAPublicKey.java   |   4 +-
 base/util/src/netscape/security/x509/AVA.java      |  15 +-
 base/util/src/netscape/security/x509/AlgIdDSA.java |  14 +-
 .../src/netscape/security/x509/AlgorithmId.java    |  43 +++--
 .../util/src/netscape/security/x509/Attribute.java |  52 +++---
 .../x509/AuthorityKeyIdentifierExtension.java      |  48 ++---
 .../security/x509/BasicConstraintsExtension.java   |  21 ++-
 .../netscape/security/x509/CRLNumberExtension.java |   9 +-
 .../netscape/security/x509/CRLReasonExtension.java |   9 +-
 .../security/x509/CertificateExtensions.java       |  39 ++--
 .../x509/CertificatePoliciesExtension.java         |  15 +-
 .../security/x509/CertificateValidity.java         |  31 ++--
 .../netscape/security/x509/CertificateVersion.java |  15 +-
 .../security/x509/DeltaCRLIndicatorExtension.java  |   9 +-
 .../util/src/netscape/security/x509/Extension.java |   3 +-
 .../src/netscape/security/x509/Extensions.java     |   9 +-
 .../security/x509/HoldInstructionExtension.java    |  10 +-
 .../security/x509/InvalidityDateExtension.java     |   9 +-
 .../netscape/security/x509/KeyUsageExtension.java  |   9 +-
 .../security/x509/NSCCommentExtension.java         |  14 +-
 .../security/x509/NameConstraintsExtension.java    |  41 +++--
 .../security/x509/PolicyConstraintsExtension.java  |  33 ++--
 .../security/x509/PolicyMappingsExtension.java     |  15 +-
 .../security/x509/PrivateKeyUsageExtension.java    |  33 ++--
 .../netscape/security/x509/RevokedCertImpl.java    |   6 +-
 .../x509/SubjectDirAttributesExtension.java        |  23 +--
 base/util/src/netscape/security/x509/X500Name.java |  28 +--
 .../src/netscape/security/x509/X509CRLImpl.java    |  10 +-
 base/util/src/netscape/security/x509/X509Cert.java |  33 ++--
 .../src/netscape/security/x509/X509CertImpl.java   |   3 +-
 .../com/netscape/security/util/StringTestUtil.java |  36 ++--
 70 files changed, 777 insertions(+), 680 deletions(-)

diff --git a/base/ca/src/com/netscape/ca/CertificateAuthority.java b/base/ca/src/com/netscape/ca/CertificateAuthority.java
index 50ef503b66939e7e40b57f535dc3b7c4da9d3ca2..91f41ebad7eb3227e7dbd160b593275d64551faa 100644
--- a/base/ca/src/com/netscape/ca/CertificateAuthority.java
+++ b/base/ca/src/com/netscape/ca/CertificateAuthority.java
@@ -960,8 +960,7 @@ public class CertificateAuthority implements ICertificateAuthority, ICertAuthori
             statsSub.startTiming("signing");
         }
 
-        try {
-            DerOutputStream out = new DerOutputStream();
+        try (DerOutputStream out = new DerOutputStream()) {
             DerOutputStream tmp = new DerOutputStream();
 
             if (algname == null) {
@@ -1034,8 +1033,7 @@ public class CertificateAuthority implements ICertificateAuthority, ICertAuthori
             statsSub.startTiming("signing");
         }
 
-        try {
-            DerOutputStream out = new DerOutputStream();
+        try (DerOutputStream out = new DerOutputStream()){
             DerOutputStream tmp = new DerOutputStream();
 
             if (certInfo == null) {
@@ -1931,8 +1929,7 @@ public class CertificateAuthority implements ICertificateAuthority, ICertAuthori
     }
 
     private BasicOCSPResponse sign(ResponseData rd) throws EBaseException {
-        try {
-            DerOutputStream out = new DerOutputStream();
+        try (DerOutputStream out = new DerOutputStream()){
             DerOutputStream tmp = new DerOutputStream();
 
             String algname = mOCSPSigningUnit.getDefaultAlgorithm();
diff --git a/base/common/src/com/netscape/certsrv/authentication/AuthToken.java b/base/common/src/com/netscape/certsrv/authentication/AuthToken.java
index 827278711aff430373ca36c014c2e0550766e68b..18e34998dbcc4c714c71ad3e0de733a9b2d69a2c 100644
--- a/base/common/src/com/netscape/certsrv/authentication/AuthToken.java
+++ b/base/common/src/com/netscape/certsrv/authentication/AuthToken.java
@@ -257,9 +257,9 @@ public class AuthToken implements IAuthToken {
         if (value == null) {
             return false;
         }
-        DerOutputStream out = new DerOutputStream();
+
         DerValue[] derValues = new DerValue[value.length];
-        try {
+        try (DerOutputStream out = new DerOutputStream()){
             for (int i = 0; i < value.length; i++) {
                 derValues[i] = new DerValue(value[i]);
             }
@@ -343,10 +343,9 @@ public class AuthToken implements IAuthToken {
         if (value == null) {
             return false;
         }
-        DerOutputStream derStream = new DerOutputStream();
         X509Certificate[] certArray = value.getCertificates();
         DerValue[] derValues = new DerValue[certArray.length];
-        try {
+        try (DerOutputStream derStream = new DerOutputStream()){
             for (int i = 0; i < certArray.length; i++) {
                 ByteArrayOutputStream byteStream = new ByteArrayOutputStream();
                 try {
@@ -386,9 +385,9 @@ public class AuthToken implements IAuthToken {
         if (value == null) {
             return false;
         }
-        DerOutputStream out = new DerOutputStream();
+
         DerValue[] derValues = new DerValue[value.length];
-        try {
+        try (DerOutputStream out = new DerOutputStream()){
             for (int i = 0; i < value.length; i++) {
                 derValues[i] = new DerValue(DerValue.tag_OctetString, value[i]);
             }
diff --git a/base/common/src/com/netscape/cms/logging/LogFile.java b/base/common/src/com/netscape/cms/logging/LogFile.java
index caada0bf5177f147a329550b5c45f1540a90427e..91ba709aab2df3dafbcd91f77f32d8a129613971 100644
--- a/base/common/src/com/netscape/cms/logging/LogFile.java
+++ b/base/common/src/com/netscape/cms/logging/LogFile.java
@@ -343,18 +343,17 @@ public class LogFile implements ILogEventListener, IExtendedPluginInfo {
         // All this streaming is lame, but Base64OutputStream needs a
         // PrintStream
         ByteArrayOutputStream output = new ByteArrayOutputStream();
-        Base64OutputStream b64 = new Base64OutputStream(new
-                PrintStream(new
-                        FilterOutputStream(output)
-                )
-                );
+        try (Base64OutputStream b64 = new Base64OutputStream(
+                new PrintStream(new FilterOutputStream(output)))) {
+            b64.write(bytes);
+            b64.flush();
 
-        b64.write(bytes);
-        b64.flush();
-
-        // This is internationally safe because Base64 chars are
-        // contained within 8859_1
-        return output.toString("8859_1");
+            // This is internationally safe because Base64 chars are
+            // contained within 8859_1
+            return output.toString("8859_1");
+        } catch (IOException e) {
+            throw e;
+        }
     }
 
     private static boolean mInSignedAuditLogFailureMode = false;
diff --git a/base/common/src/com/netscape/cms/profile/def/EnrollDefault.java b/base/common/src/com/netscape/cms/profile/def/EnrollDefault.java
index 53ec23b404d64a6b8525352b91fa2149a1c02ac9..7b4c3c74dfd78f747e64e79f06b92cc0fa10b69f 100644
--- a/base/common/src/com/netscape/cms/profile/def/EnrollDefault.java
+++ b/base/common/src/com/netscape/cms/profile/def/EnrollDefault.java
@@ -620,8 +620,7 @@ public abstract class EnrollDefault implements IPolicyDefault, ICertInfoPolicyDe
 
         // if the OID isn't valid (ex. n.n) the error isn't caught til
         // encoding time leaving a bad request in the request queue.
-        try {
-            DerOutputStream derOut = new DerOutputStream();
+        try (DerOutputStream derOut = new DerOutputStream()) {
 
             derOut.putOID(v);
             new ObjectIdentifier(new DerInputStream(derOut.toByteArray()));
diff --git a/base/common/src/com/netscape/cms/profile/def/GenericExtDefault.java b/base/common/src/com/netscape/cms/profile/def/GenericExtDefault.java
index 4a8acace1945009404a0286919750ac99e18b4c2..f344648abb258062d73f627b9136eeb09013769d 100644
--- a/base/common/src/com/netscape/cms/profile/def/GenericExtDefault.java
+++ b/base/common/src/com/netscape/cms/profile/def/GenericExtDefault.java
@@ -230,7 +230,7 @@ public class GenericExtDefault extends EnrollExtDefault {
     public Extension createExtension(IRequest request) {
         Extension ext = null;
 
-        try {
+        try (DerOutputStream out = new DerOutputStream()) {
             boolean critical = getConfigBoolean(CONFIG_CRITICAL);
             ObjectIdentifier oid = new ObjectIdentifier(getConfig(CONFIG_OID));
             byte data[] = null;
@@ -241,7 +241,6 @@ public class GenericExtDefault extends EnrollExtDefault {
                 data = getBytes(mapPattern(request, getConfig(CONFIG_DATA)));
             }
 
-            DerOutputStream out = new DerOutputStream();
             out.putOctetString(data);
 
             ext = new Extension(oid, critical, out.toByteArray());
diff --git a/base/common/src/com/netscape/cms/servlet/common/CMSTemplate.java b/base/common/src/com/netscape/cms/servlet/common/CMSTemplate.java
index 0188b781ae228bf121a94088a75b5691ca501f86..336032dd39c3c92380cd5b39d531b3c0f17048cb 100644
--- a/base/common/src/com/netscape/cms/servlet/common/CMSTemplate.java
+++ b/base/common/src/com/netscape/cms/servlet/common/CMSTemplate.java
@@ -145,14 +145,9 @@ public class CMSTemplate extends CMSFile {
         Enumeration<IArgBlock> q = null;
         IArgBlock r = null;
         CMSTemplateParams data = input;
-        HTTPOutputStreamWriter http_out = null;
 
-        if (mCharset == null)
-            http_out = new HTTPOutputStreamWriter(rout);
-        else
-            http_out = new HTTPOutputStreamWriter(rout, mCharset);
-
-        try {
+        try (HTTPOutputStreamWriter http_out = (mCharset == null ?
+                new HTTPOutputStreamWriter(rout): new HTTPOutputStreamWriter(rout, mCharset))) {
             templateLine out = new templateLine();
 
             // Output the prolog
diff --git a/base/common/src/com/netscape/cms/servlet/csadmin/GetCookie.java b/base/common/src/com/netscape/cms/servlet/csadmin/GetCookie.java
index 6e269089e4efa0741d249859164118c2caf5ed28..78d8dab6ba170405266fa96de61b17267e805464 100644
--- a/base/common/src/com/netscape/cms/servlet/csadmin/GetCookie.java
+++ b/base/common/src/com/netscape/cms/servlet/csadmin/GetCookie.java
@@ -21,7 +21,6 @@ import java.io.IOException;
 import java.net.URL;
 import java.net.URLDecoder;
 import java.util.Locale;
-import java.util.Random;
 
 import javax.servlet.ServletConfig;
 import javax.servlet.ServletException;
@@ -49,7 +48,6 @@ public class GetCookie extends CMSServlet {
      *
      */
     private static final long serialVersionUID = 2466968231929541707L;
-    private static Random mRandom = null;
     private String mErrorFormPath = null;
     private String mFormPath = null;
 
@@ -72,7 +70,6 @@ public class GetCookie extends CMSServlet {
 
         CMS.debug("GetCookie init");
         mTemplates.remove(CMSRequest.SUCCESS);
-        mRandom = new Random();
         mErrorFormPath = sc.getInitParameter("errorTemplatePath");
         if (mOutputTemplatePath != null) {
             mFormPath = mOutputTemplatePath;
diff --git a/base/common/src/com/netscape/cmscore/base/PropConfigStore.java b/base/common/src/com/netscape/cmscore/base/PropConfigStore.java
index 075d4be78f48f07f1982a5ed0fb72dca20a18f78..161f549f2148c35bcbf9e985f079394ff545984a 100644
--- a/base/common/src/com/netscape/cmscore/base/PropConfigStore.java
+++ b/base/common/src/com/netscape/cmscore/base/PropConfigStore.java
@@ -355,10 +355,8 @@ public class PropConfigStore implements IConfigStore, Cloneable {
      */
     public void putByteArray(String name, byte value[]) {
         ByteArrayOutputStream output = new ByteArrayOutputStream();
-        Base64OutputStream b64 = new Base64OutputStream(new
-                PrintStream(new FilterOutputStream(output)));
-
-        try {
+        try (Base64OutputStream b64 = new Base64OutputStream(new
+                PrintStream(new FilterOutputStream(output)))) {
             b64.write(value);
             b64.flush();
 
diff --git a/base/common/src/com/netscape/cmscore/security/KeyCertUtil.java b/base/common/src/com/netscape/cmscore/security/KeyCertUtil.java
index 210c042276b937a40bc206dce72f670834c1e8e0..9ccdc6f595ac92f925305811348b436caa369ccd 100644
--- a/base/common/src/com/netscape/cmscore/security/KeyCertUtil.java
+++ b/base/common/src/com/netscape/cmscore/security/KeyCertUtil.java
@@ -175,36 +175,38 @@ public class KeyCertUtil {
         // All this streaming is lame, but Base64OutputStream needs a
         // PrintStream
         ByteArrayOutputStream output = new ByteArrayOutputStream();
-        Base64OutputStream b64 = new Base64OutputStream(new
-                PrintStream(new
-                        FilterOutputStream(output)
-                )
-                );
+        try (Base64OutputStream b64 = new Base64OutputStream(
+                new PrintStream(new FilterOutputStream(output)))) {
 
-        b64.write(bytes);
-        b64.flush();
+            b64.write(bytes);
+            b64.flush();
 
-        // This is internationally safe because Base64 chars are
-        // contained within 8859_1
-        return output.toString("8859_1");
+            // This is internationally safe because Base64 chars are
+            // contained within 8859_1
+            return output.toString("8859_1");
+        } catch (IOException e) {
+            throw e;
+        }
     }
 
     public static byte[] makeDSSParms(BigInteger P, BigInteger Q, BigInteger G)
             throws IOException {
+        try (DerOutputStream sequence = new DerOutputStream()) {
 
-        // Write P, Q, G to a DER stream
-        DerOutputStream contents = new DerOutputStream();
+            // Write P, Q, G to a DER stream
+            DerOutputStream contents = new DerOutputStream();
 
-        contents.putInteger(new BigInt(P));
-        contents.putInteger(new BigInt(Q));
-        contents.putInteger(new BigInt(G));
+            contents.putInteger(new BigInt(P));
+            contents.putInteger(new BigInt(Q));
+            contents.putInteger(new BigInt(G));
 
-        // Make a sequence from the PQG stream
-        DerOutputStream sequence = new DerOutputStream();
+            // Make a sequence from the PQG stream
+            sequence.write(DerValue.tag_Sequence, contents);
 
-        sequence.write(DerValue.tag_Sequence, contents);
-
-        return sequence.toByteArray();
+            return sequence.toByteArray();
+        } catch (IOException e) {
+            throw e;
+        }
     }
 
     public static PrivateKey getPrivateKey(String tokenname, String nickname)
@@ -235,7 +237,7 @@ public class KeyCertUtil {
     public static X509CertImpl signCert(PrivateKey privateKey, X509CertInfo certInfo,
             SignatureAlgorithm sigAlg)
             throws NoSuchTokenException, EBaseException, NotInitializedException {
-        try {
+        try (DerOutputStream out = new DerOutputStream()) {
             CertificateAlgorithmId sId = (CertificateAlgorithmId)
                     certInfo.get(X509CertInfo.ALGORITHM_ID);
             AlgorithmId sigAlgId =
@@ -246,7 +248,6 @@ public class KeyCertUtil {
             CryptoToken token = priKey.getOwningToken();
 
             DerOutputStream tmp = new DerOutputStream();
-            DerOutputStream out = new DerOutputStream();
 
             certInfo.encode(tmp);
 
diff --git a/base/common/src/com/netscape/cmscore/security/PWsdrCache.java b/base/common/src/com/netscape/cmscore/security/PWsdrCache.java
index d723d55ed775c16632692cef5e452dc794beaaf4..bec09cdb6a4da52e7e6326e9f82dbaf71e8a0dd7 100644
--- a/base/common/src/com/netscape/cmscore/security/PWsdrCache.java
+++ b/base/common/src/com/netscape/cmscore/security/PWsdrCache.java
@@ -191,18 +191,18 @@ public class PWsdrCache {
         // All this streaming is lame, but Base64OutputStream needs a
         // PrintStream
         ByteArrayOutputStream output = new ByteArrayOutputStream();
-        Base64OutputStream b64 = new Base64OutputStream(new
-                PrintStream(new
-                        FilterOutputStream(output)
-                )
-                );
+        try (Base64OutputStream b64 = new Base64OutputStream(
+                new PrintStream(new FilterOutputStream(output)))) {
 
-        b64.write(bytes);
-        b64.flush();
+            b64.write(bytes);
+            b64.flush();
 
-        // This is internationally safe because Base64 chars are
-        // contained within 8859_1
-        return output.toString("8859_1");
+            // This is internationally safe because Base64 chars are
+            // contained within 8859_1
+            return output.toString("8859_1");
+        } catch (IOException e) {
+            throw e;
+        }
     }
 
     // for PWCBsdr
diff --git a/base/common/src/com/netscape/cmscore/util/ExceptionFormatter.java b/base/common/src/com/netscape/cmscore/util/ExceptionFormatter.java
index 88dd32a051d367ec67e72cf627a0ed6cc12f5f26..14351cd7b91cabb59a13e92617b6f55832895ac8 100644
--- a/base/common/src/com/netscape/cmscore/util/ExceptionFormatter.java
+++ b/base/common/src/com/netscape/cmscore/util/ExceptionFormatter.java
@@ -35,12 +35,10 @@ public class ExceptionFormatter {
     public static String getStackTraceAsString(Throwable e) {
         String returnvalue = e.toString();
 
-        try {
-            PipedOutputStream po = new PipedOutputStream();
-            PipedInputStream pi = new PipedInputStream(po);
+        PipedOutputStream po = new PipedOutputStream();
+        try (PipedInputStream pi = new PipedInputStream(po)) {
 
             PrintWriter ps = new PrintWriter(po);
-
             e.printStackTrace(ps);
             ps.flush();
 
@@ -52,7 +50,6 @@ public class ExceptionFormatter {
         } catch (Exception ex) {
         }
         return returnvalue;
-
     }
 
     /* test code below */
diff --git a/base/common/test/com/netscape/certsrv/authentication/AuthTokenTest.java b/base/common/test/com/netscape/certsrv/authentication/AuthTokenTest.java
index 1a5d999f6e57f003a55c21f871a3111379504a04..c4440456eb78fae9a99ea9821e44ade491bce6a7 100644
--- a/base/common/test/com/netscape/certsrv/authentication/AuthTokenTest.java
+++ b/base/common/test/com/netscape/certsrv/authentication/AuthTokenTest.java
@@ -154,9 +154,12 @@ public class AuthTokenTest extends CMSBaseTestCase {
         authToken.set("key2", new byte[] { 1, 2, 3, 4 });
         assertNull(authToken.getInStringArray("key2"));
 
-        DerOutputStream out = new DerOutputStream();
-        out.putPrintableString("testing");
-        authToken.set("key3", out.toByteArray());
+        try (DerOutputStream out = new DerOutputStream()) {
+            out.putPrintableString("testing");
+            authToken.set("key3", out.toByteArray());
+        } catch (IOException e) {
+            throw e;
+        }
         assertNull(authToken.getInStringArray("key3"));
 
         assertFalse(authToken.set("key4", (String[]) null));
diff --git a/base/java-tools/src/com/netscape/cmstools/BtoA.java b/base/java-tools/src/com/netscape/cmstools/BtoA.java
index 8c240dac6159a52b97e1e7e15b2d8a6152b7a2cb..ac4e3894285b8817d85cc59f39a8f57cc9eff2da 100644
--- a/base/java-tools/src/com/netscape/cmstools/BtoA.java
+++ b/base/java-tools/src/com/netscape/cmstools/BtoA.java
@@ -82,6 +82,10 @@ public class BtoA {
         } catch (IOException e) {
             System.out.println("BtoA():  unable to open file " +
                     argv[1] + " for writing:\n" + e);
+            try {
+                inputBlob.close();
+            } catch (IOException e1) {
+            }
             return;
         }
 
diff --git a/base/java-tools/src/com/netscape/cmstools/DRMTool.java b/base/java-tools/src/com/netscape/cmstools/DRMTool.java
index 4403dc8ecf62b63c382abefb688f88ab94fd1c45..55d1eddd1f91921c23f3bab9e73e6d20ffd2daae 100644
--- a/base/java-tools/src/com/netscape/cmstools/DRMTool.java
+++ b/base/java-tools/src/com/netscape/cmstools/DRMTool.java
@@ -1828,7 +1828,6 @@ public class DRMTool {
         KeyWrapper target_rsaWrap = null;
         byte target_session[] = null;
         DerOutputStream tmp = null;
-        DerOutputStream out = null;
         byte[] rewrappedKeyData = null;
 
         // public byte[]
@@ -1909,7 +1908,7 @@ public class DRMTool {
         // public byte[]
         // mStorageUnit.encryptInternalPrivate( byte priKey[] )
         // throws EBaseException
-        try {
+        try (DerOutputStream out = new DerOutputStream()){
             // Use "mSourceToken" to get "KeyWrapAlgorithm.RSA"
             target_rsaWrap = mSourceToken.getKeyWrapper(
                                  KeyWrapAlgorithm.RSA);
@@ -1917,7 +1916,6 @@ public class DRMTool {
             target_session = target_rsaWrap.wrap(sk);
 
             tmp = new DerOutputStream();
-            out = new DerOutputStream();
 
             tmp.putOctetString(target_session);
             tmp.putOctetString(pri);
diff --git a/base/java-tools/src/com/netscape/cmstools/ExtJoiner.java b/base/java-tools/src/com/netscape/cmstools/ExtJoiner.java
index 5aac69e60755ad96aa09420fe2871b217937af56..fed33d2dd809341cb6910ac1e99213d8e7168a77 100644
--- a/base/java-tools/src/com/netscape/cmstools/ExtJoiner.java
+++ b/base/java-tools/src/com/netscape/cmstools/ExtJoiner.java
@@ -68,7 +68,7 @@ import com.netscape.cmsutil.util.Utils;
 public class ExtJoiner {
 
     public static void main(String args[]) {
-        try {
+        try (DerOutputStream out = new DerOutputStream()) {
             if (args.length == 0) {
                 System.out.println("Usage:  ExtJoiner <ext_file0> <ext_file1> ... <ext_fileN>");
                 System.exit(0);
@@ -80,7 +80,6 @@ public class ExtJoiner {
 
                 exts[i] = new DerValue(data);
             }
-            DerOutputStream out = new DerOutputStream();
 
             out.putSequence(exts);
             System.out.println(Utils.base64encode(out.toByteArray()));
diff --git a/base/java-tools/src/com/netscape/cmstools/GenExtKeyUsage.java b/base/java-tools/src/com/netscape/cmstools/GenExtKeyUsage.java
index 9476d3ee4d582d9bcf7cbc26a904a46931f6b19b..5eb429feba6bec034f266c9a71ec0558ae7cbd11 100644
--- a/base/java-tools/src/com/netscape/cmstools/GenExtKeyUsage.java
+++ b/base/java-tools/src/com/netscape/cmstools/GenExtKeyUsage.java
@@ -19,13 +19,13 @@ package com.netscape.cmstools;
 
 import java.util.Vector;
 
-import com.netscape.cmsutil.util.Utils;
-
 import netscape.security.util.DerOutputStream;
 import netscape.security.util.DerValue;
 import netscape.security.util.ObjectIdentifier;
 import netscape.security.x509.Extension;
 
+import com.netscape.cmsutil.util.Utils;
+
 /**
  * Generates a DER-encoded Extended Key Usage extension.
  * The first parameter is the criticality of the extension, true or false.
@@ -38,7 +38,8 @@ import netscape.security.x509.Extension;
 public class GenExtKeyUsage {
 
     public static void main(String[] args) {
-        try {
+        try (DerOutputStream seq = new DerOutputStream();
+             DerOutputStream octetString = new DerOutputStream()){
             if (args.length < 2) {
                 System.out.println("Usage:  GenExtKeyUsage [true|false] <OID> ...");
                 System.exit(-1);
@@ -72,13 +73,9 @@ public class GenExtKeyUsage {
             }
 
             // stuff the object identifiers into a SEQUENCE
-            DerOutputStream seq = new DerOutputStream();
-
             seq.write(DerValue.tag_Sequence, contents);
 
             // encode the SEQUENCE in an octet string
-            DerOutputStream octetString = new DerOutputStream();
-
             octetString.putOctetString(seq.toByteArray());
 
             // Construct an extension
diff --git a/base/java-tools/src/com/netscape/cmstools/PKCS10Client.java b/base/java-tools/src/com/netscape/cmstools/PKCS10Client.java
index a138ae29d661033d747272272ff56fa2183e8112..f3eac9ff4837aae9e352d68431d6aabe293696ba 100644
--- a/base/java-tools/src/com/netscape/cmstools/PKCS10Client.java
+++ b/base/java-tools/src/com/netscape/cmstools/PKCS10Client.java
@@ -88,7 +88,7 @@ public class PKCS10Client {
     }
 
     public static void main(String args[]) throws Exception {
-        String dbdir = null, ofilename = null, password = null, subjectName = null, type = null, tokenName = null;
+        String dbdir = null, ofilename = null, password = null, subjectName = null, tokenName = null;
 
         String alg = "rsa";
         String ecc_curve = "nistp256";
diff --git a/base/java-tools/src/com/netscape/cmstools/PasswordCache.java b/base/java-tools/src/com/netscape/cmstools/PasswordCache.java
index d97a21706aa4e486437fded22a3b90dfaab0b3d6..1a451cdec8d60d3a70683f1dc1e0883aadcf34e8 100644
--- a/base/java-tools/src/com/netscape/cmstools/PasswordCache.java
+++ b/base/java-tools/src/com/netscape/cmstools/PasswordCache.java
@@ -127,18 +127,18 @@ public class PasswordCache {
         // All this streaming is lame, but Base64OutputStream needs a
         // PrintStream
         ByteArrayOutputStream output = new ByteArrayOutputStream();
-        Base64OutputStream b64 = new Base64OutputStream(new
-                PrintStream(new
-                        FilterOutputStream(output)
-                )
-                );
+        try (Base64OutputStream b64 = new Base64OutputStream(
+                new PrintStream(new FilterOutputStream(output)))) {
 
-        b64.write(bytes);
-        b64.flush();
+            b64.write(bytes);
+            b64.flush();
 
-        // This is internationally safe because Base64 chars are
-        // contained within 8859_1
-        return output.toString("8859_1");
+            // This is internationally safe because Base64 chars are
+            // contained within 8859_1
+            return output.toString("8859_1");
+        } catch (IOException e) {
+            throw e;
+        }
     }
 
     public static void main(String[] av) {
diff --git a/base/kra/src/com/netscape/kra/EncryptionUnit.java b/base/kra/src/com/netscape/kra/EncryptionUnit.java
index c6023e6c55a1887635ed22c24e55119ecb23d1b1..78f6e2719383385551d5fd679acbf424ba5f849b 100644
--- a/base/kra/src/com/netscape/kra/EncryptionUnit.java
+++ b/base/kra/src/com/netscape/kra/EncryptionUnit.java
@@ -82,7 +82,7 @@ public abstract class EncryptionUnit implements IEncryptionUnit {
      */
     public byte[] encryptInternalPrivate(byte priKey[])
             throws EBaseException {
-        try {
+        try (DerOutputStream out = new DerOutputStream()) {
             CMS.debug("EncryptionUnit.encryptInternalPrivate");
             CryptoToken internalToken = getInternalToken();
 
@@ -112,7 +112,6 @@ public abstract class EncryptionUnit implements IEncryptionUnit {
             // }
 
             DerOutputStream tmp = new DerOutputStream();
-            DerOutputStream out = new DerOutputStream();
 
             tmp.putOctetString(session);
             tmp.putOctetString(pri);
@@ -641,7 +640,7 @@ public abstract class EncryptionUnit implements IEncryptionUnit {
      * Internal wrap, accounts for either private or symmetric key
      */
     private byte[] _wrap(PrivateKey priKey, SymmetricKey symmKey) throws EBaseException {
-        try {
+        try (DerOutputStream out = new DerOutputStream()) {
             if ((priKey == null && symmKey == null) || (priKey != null && symmKey != null)) {
                 return null;
             }
@@ -691,7 +690,6 @@ public abstract class EncryptionUnit implements IEncryptionUnit {
             // }
 
             DerOutputStream tmp = new DerOutputStream();
-            DerOutputStream out = new DerOutputStream();
 
             tmp.putOctetString(session);
             tmp.putOctetString(pri);
